Function MyMod(ByVal a, ByVal b) 'Work around for vbscript's 32 bit MOD limitation
    a = Fix(CDbl(a))             'Credit: http://blogs.msdn.com/ericlippert/archive/2004/12/01/integer-arithmetic-in-vbscript-part-one.aspx
    b = Fix(CDbl(b))
    MyMod = a - Fix(a/b) * b
End Function

	Wscript.Echo ""
	Wscript.Echo ""
	Wscript.Echo "================================================================="
	Wscript.Echo "================================================================="
	Wscript.Echo "= Alignment Checking tool for all SSDs with Block Size of 512KB ="
	Wscript.Echo "================================================================="
	Wscript.Echo "================================================================="
strComputer = "."
Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
Set colDiskPartitions = objWMIService.ExecQuery _
    ("Select * from Win32_DiskPartition")
For each objPartition in colDiskPartitions
	Wscript.Echo ""
	Wscript.Echo ""
	Wscript.Echo "Device ID: " & objPartition.DeviceID       
	Wscript.Echo "=======================================================" & vbcr   
	Wscript.Echo "    Total Volume Size:      " & Round( (objPartition.Size/1024/1024/1024), 0) & " GB"
	Wscript.Echo "    Starting Offset:        " & objPartition.StartingOffset & " (" & objPartition.StartingOffset/1024 & " KB)"
	
        If (MyMod(objPartition.StartingOffset, 524288) = 0) Then
		Wscript.Echo "    Partition Alignment:    Aligned"
		Wscript.Echo ""
		Wscript.Echo "    --RAID USERS ONLY--"
		Wscript.Echo "    Alignment valid for RAID Stripe Sizes up to: " & objPartition.StartingOffset/1024 & " KB"
			If ( (objPartition.StartingOffset / 1024) < 1024 ) Then
			Wscript.Echo vbCrLf & "  * Please note, this is not necessarly a problem, however we noticed" & _
			vbCrLf & "    your starting offset is less than the Microsoft recommended size" & _
			vbCrLf & "    of 1024 KB.  Please see Microsoft's KB article 929491 for " & _
			vbCrLf & "    additional details."
			End If
	Else
		Wscript.Echo "    Partition Alignment:    ** NOT ALIGNED!! **"
	End If
	Wscript.Echo ""
	Wscript.Echo ""
Next